> For the complete documentation index, see [llms.txt](https://docs.perigee.software/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.perigee.software/transform-sdk/sdk-reference/fileioprocessdata.md).

# FileIOProcessData

### SetDataAsCSV

Set the file data to the bytes of a CSV and change the MIME type to CSV.

#### Example:

```csharp
data.SetDataAsCSV("id,name\n1,John Doe");
```

### SetDataAsJson

Set the file data to the bytes of JSON and change the MIME type to JSON.

#### Example:

```csharp
data.SetDataAsJson("{\"id\":1,\"name\":\"John Doe\"}");
```

### SetAsDataTable

Remove the file bytes and set a parsed data table.

#### Example:

```csharp
data.SetAsDataTable(new DataTable());
```

### GetEncoding

Retrieve the file encoding.

#### Example:

```csharp
Encoding encoding = data.GetEncoding;
```

### BytesToString

Convert the bytes to a string using the detected encoding from `GetEncoding`.

#### Example:

```csharp
string fileContent = data.BytesToString();
```

### TableFromFile

A helper function to get a table from a byte array and MIME type, or if the data table has been assigned, it is returned instead.

#### Example:

```csharp
DataTable dataTable = data.TableFromFile();
```

### GetConfiguration

Get a configuration value, even if it is encrypted. This method allows you to read configurations when writing plugins for the TransformClient Automation application.

#### Parameters:

* `key`: Key of the value (e.g., "AppSettings:MyAPIKey").

#### Example:

```csharp
string configValue = data.GetConfiguration("AppSettings:MyAPIKey");
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.perigee.software/transform-sdk/sdk-reference/fileioprocessdata.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
